import VirtualHostTool

## for modifying skins tool
import Products.CMFCore.SkinsTool, Products.CMFCore.SkinsContainer
from Products.CMFCore.utils import getToolByName

##for doing weird CMF mojo that I don't have time to try and understand
# from Products.CMFCore import utils

# normal things
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import CMFCorePermissions


## CMF mojo copied from CMFDefault.  I *hate* doing stuff without knowing
## exactly what's going on, but I'm in an ungodly rush...

# Make the skins available as DirectoryViews (thanks CMFAudio).
registerDirectory('skins', globals())
registerDirectory('skins/virtualhost', globals())
registerDirectory('skins/zpt_virtualhost', globals())

# This is used by a script (external method) that can be run
# to set up virtualhost in an existing CMF Site instance.
virtualhost_globals=globals()

# tools=(VirtualHostTool.VirtualHostTool,) # look ma, no brain

# ADD_CONTENT_PERMISSION = 'Add portal content'
# import sys
# this_module = sys.modules[ __name__ ]

#z_bases = utils.initializeBasesPhase1( bases, this_module )
# z_tool_bases = utils.initializeBasesPhase1( tools, this_module )

#cmfdefault_globals=globals()

# Make the skins available as DirectoryViews.
#registerDirectory('skins', globals())
#registerDirectory('help', globals())

def initialize( context ):

    #utils.initializeBasesPhase2( z_bases, context )
#    utils.initializeBasesPhase2( z_tool_bases, context )
#    utils.ToolInit('CMFVirtualHost Tool', tools=tools,
#                   product_name='CMFVirtualHost', icon='tool.gif',
#                   ).initialize( context )
    context.registerClass(
        VirtualHostTool.VirtualHostTool,
        constructors=(VirtualHostTool.manage_dummyAddVirtualHostTool,),
        visibility=None,
        permission=CMFCorePermissions.ManagePortal,
        icon='www/tool.gif'
        )
        #constructors=(VirtualHostTool.manage_addVirtualHostToolForm,
        #              VirtualHostTool.manage_addVirtualHostTool),
    context.registerHelp()
    context.registerHelpTitle('CMF Virtual Host Tool Help')


def getSkin(self, request):
    '''
    Returns the requested skin.  Modified to be restricted to virtual host
    skins when appropriate.
    '''
    vh_tool=getToolByName( self, 'portal_virtualhost', None )
    if not vh_tool: return oldGetSkin(self, request) # will this successfully avoid killing the skins tool if the vh_tool is not installed?  TEST
    # skinlist=vh_tool.getSkinOwnerChoices(request)
    varname = self.getRequestVarname()
    name = request.get(varname, None)
    skinob = None
    if name is not None and name in vh_tool.getSkinOwnerChoices(request): #skinlist:
        skinob = self.getSkinByName(name)
    if skinob is None:
        skinob = self.getSkinByName(vh_tool.getDefaultSkinName(request))
        if skinob is None:
            skinob = self.getSkinByPath('')
    return skinob

oldGetSkin=Products.CMFCore.SkinsTool.SkinsTool.getSkin
Products.CMFCore.SkinsTool.SkinsTool.getSkin=getSkin

#FYI:
# We are overriding a method of SkinsContainer, actually (should I move it there?):


#    security.declarePrivate('getSkin')
#    def getSkin(self, request):
#        '''
#        Returns the requested skin.
#        '''
#        varname = self.getRequestVarname()
#        name = request.get(varname, None)
#        skinob = None
#        if name is not None:
#            skinob = self.getSkinByName(name)
#        if skinob is None:
#            skinob = self.getSkinByName(self.getDefaultSkin())
#            if skinob is None:
#                skinob = self.getSkinByPath('')
#        return skinob
